/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package axel;

import java.util.ArrayList;
import java.util.List;
import util.Cluster;
import util.Cons;
import util.Point;
import util.Util;

/**
 *
 * @author Dunst
 */
public class KmeansForGMM {    
    private List<Cluster> clusters;
    private List<Point> samples;
    private int K;
    private int T = Cons.numHypothesis_training;
    
    public KmeansForGMM(List<Point> data, int clustersNumber){
        samples = data;
        K = clustersNumber;
        clusters = new ArrayList<Cluster>();
    }
    
    public void initializeCentroidsRandomly(){
        List<Point> centroids = new ArrayList<Point>();
        for (int i=0; i< K; i++){
            Point candidate = samples.get(getRandomIndex(samples.size()));
            while (Util.belongs(candidate, centroids)){
                candidate = samples.get(getRandomIndex(clusters.size()));
            }
            Cluster c = new Cluster(i, candidate);
            centroids.add(candidate);
            clusters.add(c);
        }
    }
    
    public static int getRandomIndex(int size)
    {
        return (int)(Math.random() * size);
    }
    
    //the centroids must be initialized before calling this method
    public void runClusterer(){
        boolean clustersHaveChanged = true;
        for(int t=0; t<T && clustersHaveChanged; t++){
            for (Cluster cl: clusters){
                cl.clear();
            }
            for(Point sample: samples){
                
                //divide samples into clusters
                List<Double> ed = new ArrayList<Double>();
                for (Cluster cl: clusters){
                    ed.add(Util.euclidDistance(cl.getCenter(), sample));
                }
                int clusterIndex = 0;
                for(int j = 1; j < clusters.size(); j++){
                    if (ed.get(j) < ed.get(clusterIndex))
                        clusterIndex = j;
                }
                clusters.get(clusterIndex).add(sample);
            }

            List<Point> centroids_old = new ArrayList<Point>();
            for (Cluster cl: clusters){
                centroids_old.add(cl.getCenter());
                cl.resetCenter();
            }

            int i=0;
            for(Cluster cl:clusters){
                if (Util.belongs(cl.getCenter(), samples))
                    i=i+1;
            }
            if (i == K-1)
                clustersHaveChanged = false;
        }
    }
    
    public List<Cluster> getClusters(){
        return clusters;
    }
}
