/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package util;

/**
 *
 * @author Dunst
 */
public class KalmanFilter {
    // predicted state
    private double X0;
    // predicted covariance
    private double P0;
    
    // factor of real value to previous real value
    private double F;
    // measurement noise
    private double Q;
    // factor of measured value to real value
    private double H;
    // environment noise
    private double R;
    
    private double state;
    private double covariance;

    public KalmanFilter(double Q, double R, double H, double F) {
        this.Q = Q;
        this.R = R;
        this.H = H;
        this.F = F;
    }
            
    public KalmanFilter(double Q, double R) {
        this.Q = Q;
        this.R = R;
        this.H = 1;
        this.F = 1;
    }

    /**
     * @return the State
     */
    public double getState() {
        return this.state;
    }

    public void setInitState(double state, double covariance) {
        this.state = state;
        this.covariance = covariance;
    }
    
    public void correct(double data){
        //time update - prediction
        X0 = F*state;
        P0 = F*covariance*F + Q;

        //measurement update - correction
        double K = H*P0/(H*P0*H + R);
        state = X0 + K*(data - H*X0);
        covariance = (1 - K*H)*P0;            
    }
}
