package webservice;

import axel.*;
import javax.jws.WebService;

@WebService
public class MovementTest {
    public MovementTest(){

    }
    
    public void testAdaBoost(){
        new PointStatistics();
        
        //training_all
        PointStatistics.loadDataFromDir("datafiles/training_half");
        AdaBoostClusterer.trainAdaBoost();
        
        PointStatistics.setTest(true);
        PointStatistics.loadDataFromDir("datafiles/test_excluded");
        AdaBoostClusterer.testAdaBoost("test_excluded");
        PointStatistics.loadDataFromDir("datafiles/test_included");
        AdaBoostClusterer.testAdaBoost("test_included");
        
        
        //training_all
        PointStatistics.setTest(false);
        PointStatistics.setUseFilter(true);
        PointStatistics.loadDataFromDir("datafiles/training_half");
        AdaBoostClusterer.trainAdaBoost();
        
        PointStatistics.setTest(true);
        PointStatistics.loadDataFromDir("datafiles/test_excluded");
        AdaBoostClusterer.testAdaBoost("test_excluded_f");
        PointStatistics.loadDataFromDir("datafiles/test_included");
        AdaBoostClusterer.testAdaBoost("test_included_f");
    }
    
    public void testGmm_EM(){
        new PointStatistics();
        
        //training_all        
        PointStatistics.loadDataFromDir("datafiles/training_all");
        GMMEMClusterer.trainGMM(5);
        
        PointStatistics.setTest(true);
        PointStatistics.loadDataFromDir("datafiles/test_excluded");
        GMMEMClusterer.testGMM("test_excluded5");
        PointStatistics.loadDataFromDir("datafiles/test_included");
        GMMEMClusterer.testGMM("test_included5");
        
        //training_all        
        PointStatistics.setTest(false);
        PointStatistics.setUseFilter(true);
        PointStatistics.loadDataFromDir("datafiles/training_all");
        GMMEMClusterer.trainGMM(5);
        
        PointStatistics.setTest(true);
        PointStatistics.loadDataFromDir("datafiles/test_excluded");
        GMMEMClusterer.testGMM("test_excluded5_f");
        PointStatistics.loadDataFromDir("datafiles/test_included");
        GMMEMClusterer.testGMM("test_included5_f");        
    }

    public void testBoostedKMeans(){
        new PointStatistics();
        
        //training1_all        
        PointStatistics.loadDataFromDir("datafiles/training_all");
        BoostedKMeansClusterer.trainBoostedKMeans();
        
        PointStatistics.setTest(true);
        PointStatistics.loadDataFromDir("datafiles/test_excluded");
        BoostedKMeansClusterer.testBoostedKMeans("test_excluded");
        PointStatistics.loadDataFromDir("datafiles/test_included");
        BoostedKMeansClusterer.testBoostedKMeans("test_included");
        
        PointStatistics.setTest(false);
        PointStatistics.setUseFilter(true);
        PointStatistics.loadDataFromDir("datafiles/training_all");
        BoostedKMeansClusterer.trainBoostedKMeans();
        
        PointStatistics.setTest(true);
        PointStatistics.loadDataFromDir("datafiles/test_excluded");
        BoostedKMeansClusterer.testBoostedKMeans("test_excluded_f");
        PointStatistics.loadDataFromDir("datafiles/test_included");
        BoostedKMeansClusterer.testBoostedKMeans("test_included_f");
    }
    
    
    
    public void testKMeanCls(){
        new PointStatistics();
        
        //training1_all        
        PointStatistics.loadDataFromDir("datafiles/training_all");
        KMeansClusterer.computeCentroidsForTrainData();
        
        PointStatistics.setTest(true);
        PointStatistics.loadDataFromDir("datafiles/test_excluded");
        KMeansClusterer.testKMeansOnAllData("test_excluded_all");
        KMeansClusterer.testKmeans("test_excluded");
        PointStatistics.loadDataFromDir("datafiles/test_included");
        KMeansClusterer.testKMeansOnAllData("test_included_all");
        KMeansClusterer.testKmeans("test_included");
        
        //training1_all 
        PointStatistics.setTest(false);
        PointStatistics.setUseFilter(true);
        PointStatistics.loadDataFromDir("datafiles/training_all");
        KMeansClusterer.computeCentroidsForTrainData();
        
        PointStatistics.setTest(true);
        PointStatistics.loadDataFromDir("datafiles/test_excluded");
        KMeansClusterer.testKMeansOnAllData("test_excluded_all_f");
        KMeansClusterer.testKmeans("test_excluded_f");
        PointStatistics.loadDataFromDir("datafiles/test_included");
        KMeansClusterer.testKMeansOnAllData("test_included_all_f");
        KMeansClusterer.testKmeans("test_included_f");
    }
    
    public void testKNN(){
        new PointStatistics();
        
        //training1_all        
        PointStatistics.loadDataFromDir("datafiles/training_all");
        KNNClusterer k = new KNNClusterer(9);
        
        PointStatistics.setTest(true);        
        PointStatistics.loadDataFromDir("datafiles/test_excluded");
        k.test("test_excluded_9");
        PointStatistics.loadDataFromDir("datafiles/test_included");
        k.test("test_included_9");
        
        //training1_all 
        PointStatistics.setTest(false);
        PointStatistics.setUseFilter(true);
        PointStatistics.loadDataFromDir("datafiles/training_all");
        k = new KNNClusterer(9);
        
        PointStatistics.setTest(true);        
        PointStatistics.loadDataFromDir("datafiles/test_excluded");
        k.test("test_excluded_9_f");
        PointStatistics.loadDataFromDir("datafiles/test_included");
        k.test("test_included_9_f");
    }    
    
}
